/* CHCP Proxy by Vasim V. */

#define IGNORE_ERROR /* ignore errors at receive and send data */

#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#include <os2.h>
#include <conio.h>
#include <types.h>
#include <netinet\in.h>
#include <sys\socket.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

#define BUFFER_SIZE 2048
#define MAX_INPUT_SOCKETS 128
#define MAX_MIME_HEADER_SIZE 1536
#define MIME_TEXT_FLAG "CONTENT-TYPE: TEXT"
#define CHARSET_FLAG "; CHARSET="

char *table_name[5] = {"KOI8-R","CP1251","ISO-8859-5","YOUR","CP866"};

typedef struct {
 	int proxy_sock;
	int in_sock;
	int table; } sockets ;

void _System new_request ( ULONG num_socket);
void _System to_proxy_thread (ULONG num_sockets);
void _System menu (ULONG null_param);
int  send_translate (int sock , char *buf, int size ,int flag_translate ,int table);
void fill_tables_translation ();
void load_table (int table,char *filename);

int number_sockets ;
int flag_exit ;
int translate_from_page ;
int translate_to_page ;
int flag_all_translate;
char table_to[5][256];
char table_from[5][256];
unsigned long proxy_address ;
unsigned short proxy_port ;
char tbcp[4][224] ;
int sock;

main (int argc ,char **argv)
{
 unsigned short port ;
 struct sockaddr_in server , client ;
 char *proxy_addr ;
 struct hostent *host_proxy;
 int res , slen ;
 TID tid_thread ;
 PFNTHREAD addr_thread;
 ULONG param_thread ;
 APIRET rc ;

 flag_exit = 0;
 sock_init ();

 if (argc != 7)
 {
	fprintf(stderr, "Usage: %s port proxy proxy_port from_codepage to_codepage flag_all_translate\r\n", argv[0]);
	exit(1);
 }

 port = (unsigned short) atoi(argv[1]) ;
 proxy_port = (unsigned short) atoi(argv[3]) ;
 proxy_addr = argv[2] ;
 translate_from_page = table_number(atoi(argv[4]));
 translate_to_page = table_number(atoi(argv[5]));
 flag_all_translate = (atoi(argv[6])!=0);

 load_table(0,"koi_866.cdp");
 load_table(1,"win_866.cdp");
 load_table(2,"iso_866.cdp");
 load_table(3,"tmp_866.cdp");

 if (!strcmpi(proxy_addr , "localhost")) proxy_address = (1*256*256*256) + 127 ;
 else
 {

	if ((proxy_addr[0] >= '0') && (proxy_addr[0] <= '9'))
		proxy_address = inet_addr(proxy_addr);
	else
	{
	 	host_proxy = gethostbyname(proxy_addr);
		if (host_proxy==NULL)
		{
			fprintf(stderr,"Proxy address %s is unknown\r\n",proxy_addr);
			exit(2);
		} else proxy_address = *((unsigned long *) host_proxy->h_addr);
	}
 }

 sock = socket(AF_INET,SOCK_STREAM,0);
 if (sock<0)
 {
	psock_errno("Create main socket");
	exit(3);
 }
 server.sin_family = AF_INET;
 server.sin_port = htons(port);
 server.sin_addr.s_addr = INADDR_ANY;

 res = bind (sock ,(struct sockaddr *)&server , sizeof(server));
 if (res<0)
 {
	psock_errno ("Bind main socket");
	exit(3);
 }

 res = listen(sock,3);
 if (res!=0)
 {
	psock_errno ("Listen main socket");
	exit(3);
 }

 number_sockets = 0;
 fill_tables_translation();
 tid_thread = 0;
 param_thread = (ULONG) 0 ;
 addr_thread = &menu;
 rc = DosCreateThread(&tid_thread , addr_thread ,
 	param_thread , CREATE_READY | STACK_SPARSE ,
	16384L) ;
 if (rc!=NO_ERROR)
 {
	fprintf(stderr,"DosCreateThread error %u\r\n",rc);
	exit (5);
 }

 do {
	slen = sizeof (client) ;
	res = accept (sock,(struct sockaddr *)&client , &slen);
	if (res>=0)
	{
		if ((number_sockets+1)>MAX_INPUT_SOCKETS)
		{
			fprintf(stderr ,"Too many thread . New request rejected\r\n");
			soclose(res);
		} else
		{
			fprintf (stderr,"New socket %d from client with address %s\r\n",res,
				inet_ntoa (client.sin_addr));
			tid_thread = 0;
			param_thread = (ULONG) res ;
			addr_thread = &new_request ;
			rc = DosCreateThread(&tid_thread , addr_thread ,
				param_thread , CREATE_READY | STACK_SPARSE ,
				8192L) ;
			if (rc!=NO_ERROR)
			{
				fprintf(stderr,"DosCreateThread error %u\r\n",rc);
				exit (5);
			}
		}
	}
 } while (!flag_exit) ;
 DosSleep(100);
 fprintf (stderr , "Exit .\r\n");
 exit(0);
};

int table_number ( int t)
{
	switch (t)
	{
		case 0 : return 0;
		case 1 : return 3;
		case 866 : return 4;
		case 1251 : return 1;
		case 8859 : return 2;
		default : return 4;
	}
};

void menu (ULONG null_param)
{
 char ch ;
 char *all_str;
 
 do {
	printf ("\r\nCHCP Proxy version 1.1 by Vasim V.\r\n\r\n");
	if (flag_all_translate) all_str="(All bytes)"; else all_str="(Text only)";
	printf ("Current translation : %s <-> %s %s\r\n\r\nKeys :\r\n\r\n",
		table_name[translate_from_page],
		table_name[translate_to_page],all_str);
	printf ("  Translate from (server's codepage) :\r\n1 From KOI-8\r\n2 From CP 1251\r\n");
	printf ("3 From ISO-8859-5\r\n4 From your codepage\r\n");
	printf ("5 From CP 866\r\n\r\n  Translate to (client's codepage) :\r\n");
	printf ("6 To KOI-8\r\n7 To CP 1251\r\n");
	printf ("8 To ISO-8859-5\r\n9 To your codepage\r\n");
	printf ("0 To 866\r\n\r\nA Translate all\r\n\r\nE Exit program\r\n\r\n");
	ch=_getch();
	switch (ch)
	{
		case '1' : {
			translate_from_page = 0;
			break; }
		case '2' : {
			translate_from_page = 1;
			break; }
		case '3' : {
			translate_from_page = 2;
			break; }
		case '4' : {
			translate_from_page = 3;
			break; }
		case '5' : {
			translate_from_page = 4;
			break; }
		case '6' : {
			translate_to_page = 0;
			fill_tables_translation ();
			break; }
		case '7' : {
			translate_to_page = 1;
			fill_tables_translation ();
			break; }
		case '8' : {
			translate_to_page = 2;
			fill_tables_translation ();
			break; }
		case '9' : {
			translate_to_page = 3;
			fill_tables_translation ();
			break; }
		case '0' : {
			translate_to_page = 4;
			fill_tables_translation ();
			break; }
		case 'A' :
		case 'a' : { flag_all_translate=!flag_all_translate ; break;}
		case 'E' :
		case 'e' : { flag_exit = 1; break; }
		default : break ;
	}
 } while (!flag_exit);
 soclose(sock);
 return ;
};

void new_request (ULONG num_socket)
{
 sockets socks ;
 TID tid_thread ;
 PFNTHREAD addr_thread;
 ULONG param_thread ;
 APIRET rc ;
 char buf[BUFFER_SIZE] ;
 char *temp_buf ;
 char *content_str;
 char *charset_str ;
 char *pos_content ;
 int res, bytes_in, i, length_content ; 
 struct sockaddr_in proxy ;
 int flag_end_thread , flag_translate ;

 number_sockets++;
 flag_end_thread = 0;
 socks.table = translate_from_page ;
 socks.in_sock = (int) num_socket ;
 socks.proxy_sock = socket (AF_INET,SOCK_STREAM,0);
 if (socks.proxy_sock <0 )
 {
	psock_errno("Create proxy socket");
	exit(6);
 }
 proxy.sin_family      = AF_INET;
 proxy.sin_port        = htons(proxy_port);
 proxy.sin_addr.s_addr = proxy_address;
 if (connect(socks.proxy_sock, (struct sockaddr *)&proxy, sizeof(proxy)) < 0)
 {
	psock_errno("Connect to proxy");
#ifndef IGNORE_ERROR
	exit(6);
 }
#else
 } else
 {
#endif
	tid_thread = 0;
	param_thread = (ULONG)&socks ;
	addr_thread = &to_proxy_thread ;
	rc = DosCreateThread(&tid_thread , addr_thread ,
		param_thread , CREATE_READY | STACK_SPARSE ,
		8192L) ; /* create thread for send from client to proxy */
	if (rc!=NO_ERROR)
	{
		fprintf(stderr,"DosCreateThread error %u\r\n",rc);
		exit (5);
	}

/* get first MAX_MIME_HEADER_SIZE bytes for detect text/html & text/plain files */

	if (!flag_all_translate)
	{
		bytes_in = 0;
		flag_translate=0;
		do {
			res = recv(socks.proxy_sock,buf+bytes_in,
				MAX_MIME_HEADER_SIZE-bytes_in-1,0);
			if (res < 0) res=0 ;
			bytes_in = bytes_in + res ;
		} while ((bytes_in < MAX_MIME_HEADER_SIZE) && (res != 0)) ;
		buf[bytes_in] = (char)0 ;
		temp_buf = (char *)malloc(bytes_in+1);
		strcpy (temp_buf,buf);
		strupr (temp_buf);
			pos_content = strstr(temp_buf,MIME_TEXT_FLAG) ;
			if (pos_content==NULL)
				send_translate (socks.in_sock,buf,bytes_in,0,0);
					/* not text file */
			else
			{
				flag_translate = 1;
				fprintf (stderr , "Socket %d : Text file detected . Code page translate is on .\r\n",
					socks.in_sock);
				content_str = (char *)malloc(bytes_in - ((int)(pos_content - temp_buf)) +1);
				for (i=0;((*(pos_content+i)!=0) && (*(pos_content+i)!='\r')
					 && (*(pos_content+i)!='\n'));i++)
					content_str[i]=*(pos_content+i);
				length_content = i ;
				content_str[i]=(char)0;
				charset_str = strstr(content_str,CHARSET_FLAG);
				if (charset_str != NULL)
				{
					for (i=0;i<5;i++)
						if (strstr(charset_str,table_name[i]) != NULL)
							socks.table=i;
					memmove(buf+(pos_content-temp_buf)+(charset_str-content_str),
						buf+(pos_content-temp_buf)+(content_str-content_str+length_content),
						bytes_in-length_content-(temp_buf-pos_content));
					bytes_in=bytes_in-(length_content-(charset_str-content_str));
				}
				free (content_str);
				send_translate (socks.in_sock,buf,
					bytes_in,1,socks.table);
				fprintf (stderr,"Socket %d : translate from codepage %s .\r\n",
					socks.in_sock,table_name[socks.table]);
			}
		free (temp_buf);
	} else flag_translate = 1 ;

/* receive end of file */

	while ((!flag_exit) && (!flag_end_thread)) {
		res = recv(socks.proxy_sock,buf,sizeof(buf),0);
		if (res==0) flag_end_thread = 1;
		else if (res<0)
		{
			psock_errno("Receive from proxy");
#ifndef IGNORE_ERROR
			exit(7);
#else
			flag_end_thread = 1;
#endif
		} else
		{
			res = send_translate(socks.in_sock,buf,res,flag_translate,socks.table);
			if (res <0)
			{
				psock_errno("Send to client");
#ifndef IGNORE_ERROR
				exit(8);
#else
				flag_end_thread = 1;
#endif
			}
		}
	}
 } 
 soclose (socks.proxy_sock);
 soclose (socks.in_sock);
 fprintf (stderr,"Socket %d closed\r\n", socks.in_sock);
 number_sockets--;
 return ;
};

void _System to_proxy_thread (ULONG num_sockets)
{
 sockets *socks ;
 char buf[BUFFER_SIZE];
 int res ;

 socks = (sockets *) num_sockets ;
 do {
	res = recv(socks->in_sock,buf,sizeof(buf),0);
	if (res==0) return ;
	else if (res<0)
	{
		return ;
	} else
	{
		res = send_translate(socks->proxy_sock,buf,res,2,socks->table);
		if (res <0)
		{
			psock_errno("Send to proxy");
#ifndef IGNORE_ERROR
			exit(8);
#else
			return ;
#endif
		}
	}
 } while (!flag_exit);
};

int send_translate (int sock ,char *buf,int size , int flag_translate , int table)
{
 int i ;

 switch (flag_translate) {
	case 0 : return send (sock , buf, size , 0);
	case 1 : {
			for (i=0;i<size;i++)
				buf[i]=table_from[table][buf[i]];
			return send (sock , buf , size ,0);
		}
	case 2 : {
			for (i=0;i<size;i++)
				buf[i]=table_to[table][buf[i]];
			return send (sock , buf , size ,0);
		}
 }
};

char char_num(int ch , char *table)
{
 int i;

 for (i=0;((i<224) && (*(table+i)!=(char)ch));i++);
 if (i==224) i=ch-32 ;
 return (char)(i+32) ;

};

void fill_tables_translation()
{
 int i , j , flag ;

 for (i=0;i<32;i++)
 {
	table_to[0][i]=(char)i; table_from[0][i]=(char)i;
	table_to[1][i]=(char)i; table_from[1][i]=(char)i;
	table_to[2][i]=(char)i; table_from[2][i]=(char)i;
	table_to[3][i]=(char)i; table_from[3][i]=(char)i;
	table_to[4][i]=(char)i; table_from[4][i]=(char)i;
 }
 for (i=0;i<5;i++)
 {
	memset(table_from[i]+32,32,224);
	memset(table_to[i]+32,32,224);
	for (j=32;j<256;j++)
	{
		if (i==translate_to_page)
		{
			table_from[i][j]=j;
			table_to[i][j]=j;
		} else
		{
			if (i==4)
			{
				table_from[i][j]=char_num(j,tbcp[translate_to_page]);
				table_to[i][j]=tbcp[translate_to_page][j-32];
			} else
			{
				if (translate_to_page==4)
				{
					table_from[i][j]=tbcp[i][j-32];
					table_to[i][j]=char_num(j,tbcp[i]);
				} else
				{
					table_from[i][j]=char_num(tbcp[i][j-32],
						tbcp[translate_to_page]);
					table_to[i][j]=char_num(tbcp[translate_to_page][j-32],
						tbcp[i]);
				}
			}
		}
	}
 }
 return ;
};

void load_table (int table , char *filename)
{
 FILE *f;

 f = fopen(filename,"rb");
 if (f==NULL)
 {
	fprintf(stderr,"Codepage file %s not loaded\r\n",filename);
	exit (1);
 }
 fread (tbcp[table],224,1,f);
 fclose(f);
 return;
};
